import { Component, Input, Injectable,Directive} from '@angular/core';
import { Feature } from 'ol';
import { Geometry } from 'ol/geom';
import { Store } from '@ngrx/store';
import * as mapReducers from '../../reducers/map.reducer';
import { commonReducers,ItemTypeService,AppConfig } from '@farmmaps/common';



@Injectable()
@Directive()
export abstract class AbstractFeatureListFeatureComponent {
  @Input() feature: Feature<Geometry>

  constructor(public store: Store<mapReducers.State | commonReducers.State>, public itemTypeService: ItemTypeService,public config:AppConfig) {
  } 
}

@Injectable()
@Component({
  selector: 'fm-map-feature-list-feature',
  templateUrl: './feature-list-feature.component.html',
  styleUrls: ['./feature-list-feature.component.scss']
})
export class FeatureListFeatureComponent extends AbstractFeatureListFeatureComponent {

  constructor(store: Store<mapReducers.State | commonReducers.State>, itemTypeService: ItemTypeService, config:AppConfig) {
    super(store, itemTypeService,config);
  }
}
